package com.logicbig.example;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.io.Resource;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;

@Configuration
public class InjectFileResourceDataExample {

    @Bean
    public ClientBean clientBean() {
        return new ClientBean();
    }

    @Bean
    public String myResourceData(
            @Value("file:D:/test/myTestFile.txt") Resource myResource) throws
            IOException {
        File file = myResource.getFile();
        return new String(Files.readAllBytes(file.toPath()));
    }

    public static void main(String[] args) throws IOException {
        System.out.println(new File("").getAbsolutePath());
        AnnotationConfigApplicationContext context =
                new AnnotationConfigApplicationContext(
                        InjectFileResourceDataExample.class);
        ClientBean bean = context.getBean(ClientBean.class);
        bean.doSomething();
    }


    private static class ClientBean {
        @Autowired
        private String myResourceData;

        public void doSomething() throws IOException {
            System.out.println(myResourceData);
        }
    }
}